#!/usr/bin/perl -w
#
# pine_wrapper.pl
# 
# Vytvori v domovskem adresari uzivatele defaultni konfiguracni 
# soubor .pinerc, pripadne upravi stavajici a spusti pine 
#
# Pouziti : pine_wrapper.pl 
#
use strict; 

my $login_name=$ENV{LOGNAME};
my($login, $dummy, $user_data, $home_dir, $passwd_record, $real_name, 
   $department_domain, $domainxtab_rec, $passwd_domain, $xtab_domain,
   $line, @lines, $found, $pinerc); 

my $passwd_file_name="/etc/passwd";
my $domainxtab_file_name="/usr/share/doc/pineorion/orion/domainxtab";
my $template_file_name="/usr/share/doc/pineorion/orion/template..pinerc.433";


###################################################
# by bodik
# pokud neni v passwd nalezena zadna domena musi si ji uzivatel vybrat sam
sub ask_domain {
	my @domain_array;
	my $tmp;
	my $i;
	my $dummy;

	my $cols = 5; # pocet sloupecku :)
format MYTAB = 
@>>>) @<<<<<<<<<<   @>>>) @<<<<<<<<<<   @>>>) @<<<<<<<<<<   @>>>) @<<<<<<<<<<   @>>>) @<<<<<<<<<<
$i,$domain_array[$i], ($i+1), $domain_array[$i+1], ($i+2), $domain_array[$i+2], ($i+3), $domain_array[$i+3], ($i+4), $domain_array[$i+4]
.

	# previneme soubor na zacatek
###	seek DOMAINXTAB, 0, 0;

	# a cteme a nacteme cele policko :)
	while( $tmp = <DOMAINXTAB> ) { 
		chop($tmp);
	        ($tmp, $dummy) = split(/ /, $tmp);
		push @domain_array, $tmp; 
	}
###	print "DEBUG: pole ma:".(@domain_array+0)."\n";


	$~="MYTAB";
	$tmp = (@domain_array+0)-((@domain_array+0) % $cols);
	for($i=0; $i<$tmp; $i += $cols) {
		write;
	}
	$~="";
	
	# jeste vytisknout ten zbytek ;))
	for( ;$i<(@domain_array+0); $i++) {
		print " $i) $domain_array[$i]           ";
	}
	
	print "\n\nNebyla nalezena domena vaseho postovniho uctu. Vyberte ji prosim ze seznamu: ";
	$tmp = <STDIN>;

###	print "DEBUG: zadano: $tmp";
	
	$department_domain = $domain_array[$tmp];
		
	return;
}
#####################################


#my $domainxtab_file_name="/afs/zcu.cz/common/scripts/domainxtab";
#my $template_file_name="/afs/zcu.cz/common/scripts/template..pinerc.433";
#
# V /etc/passwd vyhleda zaznam pro prihlaseneho uzivatele a nastavi
# promenne $real_name="Jmeno Prijmeni" a $department_domain="Zkr. katedry"
#

## STARA VERZE --- nepodporujici LDAPorion !
##open(DATA, $passwd_file_name) or die "ERROR $passwd_file_name - $!";;
##
open(DATA, "getent passwd $login_name |") or die "ERROR: nelze vyhledat uzivatelska data - $!";;
while ( $passwd_record = <DATA> ) {
 ($login,$dummy,$dummy,$dummy,$user_data,$home_dir) = split(/:/,$passwd_record);
 if ( $login_name eq $login ) {
   ($real_name, $dummy, $dummy, $dummy, 
                $dummy, $dummy, $dummy, $dummy, 
                        $department_domain ) = split(/,/,$user_data); 
   $department_domain = lc($department_domain);

  last;
 }; 
};
close(DATA);


#
# Provede test  zda existuje soubor .pinerc, pokud ne vytvori jej z
# template. Pokud exituje zkontroluje, zda obsahuje smtp-server=smtp.zcu.cz
# V pripade ze ne, doplni toto nastaveni do .pinerc 
# Zaroven se take nastavi last-version-used=4.44 (soucasna verze pine)
#
$pinerc="$home_dir/.pinerc"; 
#
if ( -r "$pinerc" ) {
 #
 # kontrola zda .pinerc obsahuje nastaveni last-version-used=4.44
 open(PINERC, "$pinerc") or die "ERROR - $pinerc - $!";

 undef($found);
 while( $line=<PINERC> ) {
  if ( $line =~ /last-version-used=4.44/) {
   $found = "YES";
   last;  
  };
 };
 close(PINERC);
 
 # V pripade ze neni last-version-used=4.44 provede se 
 # nastaveni smtp-server a last-version-used 
 unless ($found) {
  open(PINERC, "$pinerc") or die "ERROR - $pinerc - $!";
  @lines = <PINERC>;
  close(PINERC);
  open(PINERC, ">$pinerc") or die "ERROR - $pinerc - $!"; 
  foreach $line (@lines) {
    if ( $line =~ /smtp-server=/ ) {
      $line="smtp-server=smtp.zcu.cz\n";
    }; 
    if ( $line =~ /last-version-used=/ ) {
      $line="last-version-used=4.44\n";
    }; 
    print(PINERC $line);
  }; 
  close(PINERC);
  print "mk_pinerc - smtp-server set to smtp.zcu.cz.\n";
  print "            last-version-used set to 4.44.\n";
 };
} else {
 print "mk_pinerc - Installing default configuration file.\n";
 #
 # Upravi obsah promenne $department_domain na zaklade obsahu tabulky 
 # domainxtab
 # 
 open(DOMAINXTAB, $domainxtab_file_name) or die "ERROR $domainxtab_file_name - $!";

## by bodik
 if ( $department_domain eq "" ) { print "nensel jsem domenu\n"; ask_domain(); }
 # asi jsem cetl soubor proto jej musim previnout :)
 seek DOMAINXTAB, 0, 0;
##

 while( $domainxtab_rec = <DOMAINXTAB> ) {
  chop($domainxtab_rec);
  ($passwd_domain, $xtab_domain) = split(/ /, $domainxtab_rec);
  if ( ($passwd_domain eq $department_domain) and $xtab_domain ) {
    $department_domain = $xtab_domain;
  };
 };
 close(DOMAINXTAB);
 
 $department_domain = $department_domain.".zcu.cz";
 
 #
 # V souboru template..pinerc nahradi retezce $REAL_NAME a $DEPARTMENT_DOMAIN
 # a last-version-used=4.33 obsahem promennych $real_name a $department_domain
 # a aktualni verzi pine 4.44
 #
 open(PINERC, ">$pinerc") or die "ERROR - $pinerc - $!";
 open(TEMPLATE, "$template_file_name") or die "ERROR $template_file_name - $!";
 while( $line = <TEMPLATE>) {
  $line =~ s/\$REAL_NAME/$real_name/;
  $line =~ s/\$DEPARTMENT_DOMAIN/$department_domain/;
  $line =~ s/last-version-used=4.33/last-version-used=4.44/;
  print(PINERC $line);
 }; 
 close(TEMPLATE);
 close(PINERC);
};
#
# Spusteni pine
# Parametr -bail je pouzit protoi, aby se v pripade ze se nepodari
# vytvorit .pinerc pomoci tohoto wrapperu nevytvarel defaultni
# pinerc na zaklade /etc/pine.conf 
# 
####print "DEBUG: spoustim pine :)\n";
exec ('/usr/bin/pine.bin', '-bail', @ARGV ) or die "Nelze spustit pine\n";
